/*
  kwsPlusShooter.h.cpp -

  Copyright 2008 Centre National de la Recherche Scientifique (CNRS)

  Authors: Alireza Nakhaei,

*/
/*****************************************
 INCLUDES
*******************************************/


#ifndef KWS_SHHOTER_H
#define KWS_SHHOTER_H

/*************************************
INCLUDE
**************************************/
#include <iostream>
#include <fstream>

#include "KineoWorks2/kwsConfig.h"

#include "KineoWorks2/kwsShooterRoadmapBox.h"
#include "KineoWorks2/kwsShooterPath.h"
#include "KineoWorks2/kwsShooterConfigSpace.h"

#include <iostream>
#include <string>
#include <sstream>
#include <ctime>



using namespace std ;
KIT_PREDEF_CLASS ( CkwsPlusShooter );
/*************************************
CLASS
**************************************/
/**
   \brief Implements a class which allows to follow a the number of successful and non successful shoots

   see class CkwsShooter in the KineoWorks Reference Guide

*/
class CkwsPlusShooter : public CkwsShooterConfigSpace
{

	public :
		/**
		   \brief   Destructor.
		*/
		virtual ~CkwsPlusShooter() ;

		static CkwsPlusShooterShPtr create ();

		void lastShootWasUseful ( const CkwsNodeConstShPtr &i_extendedNode, const CkwsNodeConstShPtr &i_newNode, CkwsRoadmapBuilder::EDirection i_direction );

		void lastShootWasUseless ( const CkwsNodeConstShPtr &i_extendedNode, CkwsRoadmapBuilder::EDirection i_direction );

	protected :
		/**
		   \brief Protected constructor
		*/
		CkwsPlusShooter ( );

		/**
		   \brief initialization: store weak pointer to itself
		*/
		ktStatus init ( const CkwsPlusShooterWkPtr &inWeakPtr );

	private :

		/**
		   \brief Store weak pointer to object
		*/
		CkwsPlusShooterWkPtr attWeakPtr;

		/**
		   \brief Total number of successful shoot
		 */
		long int nbAcceptedShoot;

		/**
		   \brief Total number of not successful shoot
		 */

		long int nbNotAcceptedShoot;


};
//}
#endif
