/*
  hppNextBestViewPlanner.h.cpp -

  Copyright 2008 Centre National de la Recherche Scientifique (CNRS)

  Authors: Alireza Nakhaei,

*/
/*****************************************
 INCLUDES
*******************************************/

#include <iostream>
#include "hppWorldModelPlanner/kwsPlusShooter.h"


// Select verbosity at configuration by setting CXXFLAGS="... -DDEBUG=[1 or 2]"
#if DEBUG==2
#define ODEBUG2(x) std::cout << "kwsPlusShooter:" << x << std::endl
#define ODEBUG1(x) std::cerr << "kwsPlusShooter:" << x << std::endl
#elif DEBUG==1
#define ODEBUG2(x)
#define ODEBUG1(x) std::cerr << "kwsPlusShooter:" << x << std::endl
#else
#define ODEBUG2(x)
#define ODEBUG1(x)
#endif


//constructor

CkwsPlusShooter::CkwsPlusShooter( )
{
	nbAcceptedShoot=0;
	nbNotAcceptedShoot =0;
	ODEBUG2( "Constructor of class CkwsPlusShooter." );
}

// =========================================================================================

CkwsPlusShooter::~CkwsPlusShooter()
{
	ODEBUG2( "------------------------------------------------------------------" );
	ODEBUG2( "              Destructor of class CkwsPlusShooter." );
	ODEBUG2( "------------------------------------------------------------------" );
}
// =========================================================================================
CkwsPlusShooterShPtr CkwsPlusShooter::create()
{
	CkwsPlusShooter*  flatPtr = new CkwsPlusShooter();
	CkwsPlusShooterShPtr flatShPtr ( flatPtr );
	CkwsPlusShooterWkPtr flatWkPtr ( flatShPtr );
	if ( flatPtr->init ( flatWkPtr ) != KD_OK ) flatShPtr.reset();

	return flatShPtr;
}
// =========================================================================================
ktStatus CkwsPlusShooter::init ( const CkwsPlusShooterWkPtr &inWeakPtr )
{
	ktStatus success = this->CkwsShooterConfigSpace::init ( inWeakPtr ) ;

	if ( KD_OK == success )
	{
		attWeakPtr = inWeakPtr;
	}
	return success;
}
// =========================================================================================
void CkwsPlusShooter::lastShootWasUseful ( const CkwsNodeConstShPtr &i_extendedNode, const CkwsNodeConstShPtr &i_newNode, CkwsRoadmapBuilder::EDirection i_direction )
{
	nbAcceptedShoot++;
	ODEBUG2("nb of successful shoot = "  << nbAcceptedShoot);
	ODEBUG2("nb of Not successful shoot=   "  <<nbNotAcceptedShoot);
	ODEBUG2("p_shoot = "  << ( double ) nbAcceptedShoot/ ( nbNotAcceptedShoot+nbAcceptedShoot ));
}
// =========================================================================================

void CkwsPlusShooter::lastShootWasUseless ( const CkwsNodeConstShPtr &i_extendedNode, CkwsRoadmapBuilder::EDirection i_direction )
{
	nbNotAcceptedShoot++;
}


